/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@angular/core"),require("@angular/common"),require("rxjs"),require("rxjs/operators")):"function"==typeof define&&define.amd?define("@angular/flex-layout/core",["exports","@angular/core","@angular/common","rxjs","rxjs/operators"],t):t((e.ng=e.ng||{},e.ng["flex-layout"]=e.ng["flex-layout"]||{},e.ng["flex-layout"].core={}),e.ng.core,e.ng.common,e.rxjs,e.rxjs.operators)}(this,function(e,t,i,r,n){"use strict";function o(e,t){function i(){this.constructor=e}x(e,t),e.prototype=null===t?Object.create(t):(i.prototype=t.prototype,new i)}function a(e,t){return function(){if(i.isPlatformBrowser(t)){var r=/\bflex-layout-.+?\b/g;Array.from(e.querySelectorAll("[class*="+M+"]")).forEach(function(e){e.classList.contains(M+"ssr")&&e.parentNode?e.parentNode.removeChild(e):e.className.replace(r,"")})}}}function s(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];if(null==e)throw TypeError("Cannot convert undefined or null to object");for(var r=0,n=t;r<n.length;r++){var o=n[r];if(null!=o)for(var a in o)o.hasOwnProperty(a)&&(e[a]=o[a])}return e}function u(e){var t=e.length>0?e.charAt(0):"",i=e.length>1?e.slice(1):"";return t.toUpperCase()+i}function p(e){return e.replace(L,"|").split("|").map(u).join("")}function c(e){return e.forEach(function(e){e.suffix||(e.suffix=p(e.alias),e.overlapping=!!e.overlapping)}),e}function l(e,t){void 0===t&&(t=[]);var i={};return e.forEach(function(e){i[e.alias]=e}),t.forEach(function(e){i[e.alias]?s(i[e.alias],e):i[e.alias]=e}),c(Object.keys(i).map(function(e){return i[e]}))}function y(e){return void 0===e?[]:"string"==typeof e?[e]:f(e)}function f(e){var t={};return e.filter(function(e){return!t.hasOwnProperty(e)&&(t[e]=!0)})}function h(e,t){return s(e,t?{mqAlias:t.alias,suffix:t.suffix}:{})}function d(e){return e||new Y}function v(e){var t=_(e);return g(t[0],t[1],t[2])}function _(e){e=e?e.toLowerCase():"";var t=e.split(" "),i=t[0],r=t[1],n=t[2];return X.find(function(e){return e===i})||(i=X[0]),r===J&&(r=n!==J?n:"",n=J),[i,m(r),!!n]}function m(e){if(e)switch(e.toLowerCase()){case"reverse":case"wrap-reverse":case"reverse-wrap":e="wrap-reverse";break;case"no":case"none":case"nowrap":e="nowrap";break;default:e="wrap"}return e}function g(e,t,i){return void 0===t&&(t=null),void 0===i&&(i=!1),{display:i?"inline-flex":"flex","box-sizing":"border-box","flex-direction":e,"flex-wrap":t||null}}function b(e,t,i){return e||new ce(t,i)}function A(e,t,i){return e||new W(i,t)}function I(e){for(var t in e){var i=e[t]||"";switch(t){case"display":e.display="flex"===i?["-webkit-flex","flex"]:"inline-flex"===i?["-webkit-inline-flex","inline-flex"]:i;break;case"align-items":case"align-self":case"align-content":case"flex":case"flex-basis":case"flex-flow":case"flex-grow":case"flex-shrink":case"flex-wrap":case"justify-content":e["-webkit-"+t]=i;break;case"flex-direction":i=i||"row",e["-webkit-flex-direction"]=i,e["flex-direction"]=i;break;case"order":e.order=e["-webkit-"+t]=isNaN(i)?"0":i}}return e}function w(e,t,i){void 0===t&&(t="1"),void 0===i&&(i="1");var r=[t,i,e],n=e.indexOf("calc");if(n>0){r[2]=O(e.substring(n).trim());var o=e.substr(0,n).trim().split(" ");2==o.length&&(r[0]=o[0],r[1]=o[1])}else if(0==n)r[2]=O(e.trim());else{var o=e.split(" ");r=3===o.length?o:[t,i,e]}return r}function O(e){return e.replace(/[\s]/g,"").replace(/[\/\*\+\-]/g," $& ")}var x=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i])},E={provide:t.APP_BOOTSTRAP_LISTENER,useFactory:a,deps:[i.DOCUMENT,t.PLATFORM_ID],multi:!0},M="flex-layout-",j=new t.InjectionToken("Flex Layout token, collect all breakpoints into one provider",{providedIn:"root",factory:function(){return null}}),S=["xs","gt-xs","sm","gt-sm","md","gt-md","lg","gt-lg","xl"],P=[{alias:"xs",mediaQuery:"(min-width: 0px) and (max-width: 599px)"},{alias:"gt-xs",overlapping:!0,mediaQuery:"(min-width: 600px)"},{alias:"lt-sm",overlapping:!0,mediaQuery:"(max-width: 599px)"},{alias:"sm",mediaQuery:"(min-width: 600px) and (max-width: 959px)"},{alias:"gt-sm",overlapping:!0,mediaQuery:"(min-width: 960px)"},{alias:"lt-md",overlapping:!0,mediaQuery:"(max-width: 959px)"},{alias:"md",mediaQuery:"(min-width: 960px) and (max-width: 1279px)"},{alias:"gt-md",overlapping:!0,mediaQuery:"(min-width: 1280px)"},{alias:"lt-lg",overlapping:!0,mediaQuery:"(max-width: 1279px)"},{alias:"lg",mediaQuery:"(min-width: 1280px) and (max-width: 1919px)"},{alias:"gt-lg",overlapping:!0,mediaQuery:"(min-width: 1920px)"},{alias:"lt-xl",overlapping:!0,mediaQuery:"(max-width: 1920px)"},{alias:"xl",mediaQuery:"(min-width: 1920px) and (max-width: 5000px)"}],k="(orientation: landscape) and (min-width: 960px) and (max-width: 1279px)",T="(orientation: portrait) and (min-width: 600px) and (max-width: 839px)",Q="(orientation: portrait) and (min-width: 840px)",B="(orientation: landscape) and (min-width: 1280px)",R={HANDSET:"(orientation: portrait) and (max-width: 599px), (orientation: landscape) and (max-width: 959px)",TABLET:T+" , "+k,WEB:Q+", "+B+" ",HANDSET_PORTRAIT:"(orientation: portrait) and (max-width: 599px)",TABLET_PORTRAIT:T+" ",WEB_PORTRAIT:""+Q,HANDSET_LANDSCAPE:"(orientation: landscape) and (max-width: 959px)]",TABLET_LANDSCAPE:""+k,WEB_LANDSCAPE:""+B},D=[{alias:"handset",mediaQuery:R.HANDSET},{alias:"handset.landscape",mediaQuery:R.HANDSET_LANDSCAPE},{alias:"handset.portrait",mediaQuery:R.HANDSET_PORTRAIT},{alias:"tablet",mediaQuery:R.TABLET},{alias:"tablet.landscape",mediaQuery:R.TABLET},{alias:"tablet.portrait",mediaQuery:R.TABLET_PORTRAIT},{alias:"web",mediaQuery:R.WEB,overlapping:!0},{alias:"web.landscape",mediaQuery:R.WEB_LANDSCAPE,overlapping:!0},{alias:"web.portrait",mediaQuery:R.WEB_PORTRAIT,overlapping:!0}],L=/(\.|-|_)/g,C={addFlexToParent:!0,addOrientationBps:!1,disableDefaultBps:!1,disableVendorPrefixes:!1,serverLoaded:!1,useColumnBasisZero:!0},N=new t.InjectionToken("Flex Layout token, config options for the library",{providedIn:"root",factory:function(){return C}}),K=new t.InjectionToken("Token (@angular/flex-layout) Breakpoints",{providedIn:"root",factory:function(){var e=t.inject(j),i=t.inject(N),r=[].concat.apply([],(e||[]).map(function(e){return Array.isArray(e)?e:[e]}));return l((i.disableDefaultBps?[]:P).concat(i.addOrientationBps?D:[]),r)}}),q=function(){function e(e){this._registry=e}return Object.defineProperty(e.prototype,"items",{get:function(){return this._registry.slice()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"sortedItems",{get:function(){var e=this._registry.filter(function(e){return!0===e.overlapping}),t=this._registry.filter(function(e){return!0!==e.overlapping});return e.concat(t)},enumerable:!0,configurable:!0}),e.prototype.findByAlias=function(e){return this._registry.find(function(t){return t.alias==e})||null},e.prototype.findByQuery=function(e){return this._registry.find(function(t){return t.mediaQuery==e})||null},Object.defineProperty(e.prototype,"overlappings",{get:function(){return this._registry.filter(function(e){return 1==e.overlapping})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"aliases",{get:function(){return this._registry.map(function(e){return e.alias})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"suffixes",{get:function(){return this._registry.map(function(e){return e.suffix?e.suffix:""})},enumerable:!0,configurable:!0}),e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ctorParameters=function(){return[{type:Array,decorators:[{type:t.Inject,args:[K]}]}]},e.ngInjectableDef=t.defineInjectable({factory:function(){return new e(t.inject(K))},token:e,providedIn:"root"}),e}(),V=function(){function e(e,t,i,r){void 0===e&&(e=!1),void 0===t&&(t="all"),void 0===i&&(i=""),void 0===r&&(r=""),this.matches=e,this.mediaQuery=t,this.mqAlias=i,this.suffix=r}return e.prototype.clone=function(){return new e(this.matches,this.mediaQuery,this.mqAlias,this.suffix)},e}(),F=function(){function e(e,t,i){this._zone=e,this._platformId=t,this._document=i,this._registry=new Map,this._source=new r.BehaviorSubject(new V(!0)),this._observable$=this._source.asObservable()}return e.prototype.isActive=function(e){var t=this._registry.get(e);return!!t&&t.matches},e.prototype.observe=function(e){return e&&this.registerQuery(e),this._observable$.pipe(n.filter(function(t){return!e||t.mediaQuery===e}))},e.prototype.registerQuery=function(e){var t=this,i=y(e);i.length>0&&(this._prepareQueryCSS(i,this._document),i.forEach(function(e){var i=t._registry.get(e),r=function(i){t._zone.run(function(){var r=new V(i.matches,e);t._source.next(r)})};i||(i=t._buildMQL(e),i.addListener(r),t._registry.set(e,i)),i.matches&&r(i)}))},e.prototype._buildMQL=function(e){return i.isPlatformBrowser(this._platformId)&&!!window.matchMedia("all").addListener?window.matchMedia(e):{matches:"all"===e||""===e,media:e,addListener:function(){},removeListener:function(){}}},e.prototype._prepareQueryCSS=function(e,t){var i=e.filter(function(e){return!z[e]});if(i.length>0){var r=i.join(", ");try{var n=t.createElement("style");if(n.setAttribute("type","text/css"),!n.styleSheet){var o="\n/*\n  @angular/flex-layout - workaround for possible browser quirk with mediaQuery listeners\n  see http://bit.ly/2sd4HMP\n*/\n@media "+r+" {.fx-query-test{ }}\n";n.appendChild(t.createTextNode(o))}t.head.appendChild(n),i.forEach(function(e){return z[e]=n})}catch(e){console.error(e)}}},e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ctorParameters=function(){return[{type:t.NgZone},{type:Object,decorators:[{type:t.Inject,args:[t.PLATFORM_ID]}]},{type:void 0,decorators:[{type:t.Inject,args:[i.DOCUMENT]}]}]},e.ngInjectableDef=t.defineInjectable({factory:function(){return new e(t.inject(t.NgZone),t.inject(t.PLATFORM_ID),t.inject(i.DOCUMENT))},token:e,providedIn:"root"}),e}(),z={},U=function(){function e(){}return e}(),W=function(){function e(e,t){this.breakpoints=e,this.mediaWatcher=t,this.filterOverlaps=!0,this._registerBreakPoints(),this.observable$=this._buildObservable()}return e.prototype.isActive=function(e){var t=this._toMediaQuery(e);return this.mediaWatcher.isActive(t)},e.prototype.subscribe=function(e,t,i){return this.observable$.subscribe(e,t,i)},e.prototype.asObservable=function(){return this.observable$},e.prototype._registerBreakPoints=function(){var e=this.breakpoints.sortedItems.map(function(e){return e.mediaQuery});this.mediaWatcher.registerQuery(e)},e.prototype._buildObservable=function(){var e=this,t=this,i=this.mediaWatcher.observe(),r=function(e){return!0===e.matches},o=function(t){return h(t,e._findByQuery(t.mediaQuery))},a=function(i){var r=e.breakpoints.findByQuery(i.mediaQuery);return!r||!(t.filterOverlaps&&r.overlapping)};return i.pipe(n.filter(r),n.filter(a),n.map(o))},e.prototype._findByAlias=function(e){return this.breakpoints.findByAlias(e)},e.prototype._findByQuery=function(e){return this.breakpoints.findByQuery(e)},e.prototype._toMediaQuery=function(e){var t=this._findByAlias(e)||this._findByQuery(e);return t?t.mediaQuery:e},e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ctorParameters=function(){return[{type:q},{type:F}]},e.ngInjectableDef=t.defineInjectable({factory:function(){return new e(t.inject(q),t.inject(F))},token:e,providedIn:"root"}),e}(),H={provide:U,useClass:W},$=function(){function e(){}return e.decorators=[{type:t.NgModule,args:[{providers:[H,E]}]}],e.ctorParameters=function(){return[]},e}(),Y=function(){function e(){this.stylesheet=new Map}return e.prototype.addStyleToElement=function(e,t,i){var r=this.stylesheet.get(e);r?r.set(t,i):this.stylesheet.set(e,new Map([[t,i]]))},e.prototype.clearStyles=function(){this.stylesheet.clear()},e.prototype.getStyleForElement=function(e,t){var i=this.stylesheet.get(e),r="";if(i){var n=i.get(t);"number"!=typeof n&&"string"!=typeof n||(r=n+"")}return r},e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ctorParameters=function(){return[]},e.ngInjectableDef=t.defineInjectable({factory:function(){return new e},token:e,providedIn:"root"}),e}(),Z={provide:Y,deps:[[new t.Optional,new t.SkipSelf,Y]],useFactory:d},G=new t.InjectionToken("FlexLayoutServerLoaded",{providedIn:"root",factory:function(){return!1}}),J="inline",X=["row","column","row-reverse","column-reverse"],ee=function(){function e(e,t,i){this.baseKey=e,this.defaultValue=t,this.inputKeys=i}return e}(),te=function(){function e(e,t,i){this._options=e,this._mediaMonitor=t,this._onMediaChanges=i,this._subscribers=[],this._registryMap=this._buildRegistryMap(),this._subscribers=this._configureChangeObservers()}return Object.defineProperty(e.prototype,"registryFromLargest",{get:function(){return this._registryMap.slice().reverse()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"mediaMonitor",{get:function(){return this._mediaMonitor},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"activatedInputKey",{get:function(){return this._activatedInputKey||this._options.baseKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"activatedInput",{get:function(){var e=this.activatedInputKey;return this.hasKeyValue(e)?this._lookupKeyValue(e):this._options.defaultValue},enumerable:!0,configurable:!0}),e.prototype.hasKeyValue=function(e){return void 0!==this._options.inputKeys[e]},e.prototype.destroy=function(){this._subscribers.forEach(function(e){e.unsubscribe()}),this._subscribers=[]},e.prototype._configureChangeObservers=function(){var e=this,t=[];return this._registryMap.forEach(function(i){if(e._keyInUse(i.key)){var r=function(t){return t=t.clone(),t.property=e._options.baseKey,t};t.push(e.mediaMonitor.observe(i.alias).pipe(n.map(r)).subscribe(function(t){e._onMonitorEvents(t)}))}}),t},e.prototype._buildRegistryMap=function(){var e=this;return this.mediaMonitor.breakpoints.map(function(t){return s({},t,{baseKey:e._options.baseKey,key:e._options.baseKey+t.suffix})}).filter(function(t){return e._keyInUse(t.key)})},e.prototype._onMonitorEvents=function(e){e.property==this._options.baseKey&&(e.value=this._calculateActivatedValue(e),this._onMediaChanges(e))},e.prototype._keyInUse=function(e){return void 0!==this._lookupKeyValue(e)},e.prototype._calculateActivatedValue=function(e){var t=this._options.baseKey+e.suffix,i=this._activatedInputKey;return i=e.matches?t:i==t?"":i,this._activatedInputKey=this._validateInputKey(i),this.activatedInput},e.prototype._validateInputKey=function(e){var t=this,i=function(e){return!t._keyInUse(e)};return i(e)&&this.mediaMonitor.activeOverlaps.some(function(r){var n=t._options.baseKey+r.suffix;return!i(n)&&(e=n,!0)}),e},e.prototype._lookupKeyValue=function(e){return this._options.inputKeys[e]},e}(),ie=function(){function e(e,t,i){this._mediaMonitor=e,this._elementRef=t,this._styler=i,this._inputMap={},this._hasInitialized=!1}return Object.defineProperty(e.prototype,"hasMediaQueryListener",{get:function(){return!!this._mqActivation},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"activatedValue",{get:function(){return this._mqActivation?this._mqActivation.activatedInput:void 0},set:function(e){var i,r="baseKey";this._mqActivation&&(r=this._mqActivation.activatedInputKey,i=this._inputMap[r],this._inputMap[r]=e);var n=new t.SimpleChange(i,e,!1);this.ngOnChanges((o={},o[r]=n,o));var o},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parentElement",{get:function(){return this._elementRef.nativeElement.parentNode},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"nativeElement",{get:function(){return this._elementRef.nativeElement},enumerable:!0,configurable:!0}),e.prototype._queryInput=function(e){return this._inputMap[e]},e.prototype.ngOnInit=function(){this._display=this._getDisplayStyle(),this._hasInitialized=!0},e.prototype.ngOnChanges=function(e){throw new Error("BaseDirective::ngOnChanges should be overridden in subclass: "+e)},e.prototype.ngOnDestroy=function(){this._mqActivation&&this._mqActivation.destroy(),delete this._mediaMonitor},e.prototype._getDefaultVal=function(e,t){var i=this._queryInput(e);return void 0!==i&&null!==i&&""!==i?i:t},e.prototype._getDisplayStyle=function(e){void 0===e&&(e=this.nativeElement);return this._styler.lookupStyle(e,"display")},e.prototype._getAttributeValue=function(e,t){return void 0===t&&(t=this.nativeElement),this._styler.lookupAttributeValue(t,e)},e.prototype._getFlexFlowDirection=function(e,t){void 0===t&&(t=!1);var i="row",r="";if(e&&(a=this._styler.getFlowDirection(e),i=a[0],r=a[1],!r&&t)){var n=v(i),o=[e];this._styler.applyStyleToElements(n,o)}return i.trim()||"row";var a},e.prototype._applyStyleToElement=function(e,t,i){void 0===i&&(i=this.nativeElement),this._styler.applyStyleToElement(i,e,t)},e.prototype._applyStyleToElements=function(e,t){this._styler.applyStyleToElements(e,t)},e.prototype._cacheInput=function(e,t){if("object"==typeof t)for(var i in t)this._inputMap[i]=t[i];else e&&(this._inputMap[e]=t)},e.prototype._listenForMediaQueryChanges=function(e,t,i){if(!this._mqActivation){var r=new ee(e,t,this._inputMap);this._mqActivation=new te(r,this._mediaMonitor,function(e){return i(e)})}return this._mqActivation},Object.defineProperty(e.prototype,"childrenNodes",{get:function(){for(var e=this.nativeElement.children,t=[],i=e.length;i--;)t[i]=e[i];return t},enumerable:!0,configurable:!0}),e.prototype.hasResponsiveAPI=function(e){return Object.keys(this._inputMap).length-(this._inputMap[e]?1:0)>0},e.prototype.hasKeyValue=function(e){return this._mqActivation.hasKeyValue(e)},Object.defineProperty(e.prototype,"hasInitialized",{get:function(){return this._hasInitialized},enumerable:!0,configurable:!0}),e}(),re=function(e){function t(t,i,r,n){var o=e.call(this,i,r,n)||this;return o._baseKey=t,o._mediaMonitor=i,o._elementRef=r,o._styler=n,o}return o(t,e),Object.defineProperty(t.prototype,"activeKey",{get:function(){var e=this._mqActivation,t=e?e.activatedInputKey:this._baseKey;return"class"===t?"klazz":t},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"inputMap",{get:function(){return this._inputMap},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"mqActivation",{get:function(){return this._mqActivation},enumerable:!0,configurable:!0}),t.prototype.hasResponsiveAPI=function(){return e.prototype.hasResponsiveAPI.call(this,this._baseKey)},t.prototype.queryInput=function(e){return e?this._queryInput(e):void 0},t.prototype.cacheInput=function(e,t,i){if(void 0===i&&(i=!1),i)this._cacheInputRaw(e,t);else if(Array.isArray(t))this._cacheInputArray(e,t);else if("object"==typeof t)this._cacheInputObject(e,t);else{if("string"!=typeof t)throw new Error("Invalid class value '"+e+"' provided. Did you want to cache the raw value?");this._cacheInputString(e,t)}},t.prototype.listenForMediaQueryChanges=function(e,t,i){return this._listenForMediaQueryChanges(e,t,i)},t.prototype._cacheInputRaw=function(e,t){e&&(this._inputMap[e]=t)},t.prototype._cacheInputArray=function(e,t){void 0===e&&(e=""),this._inputMap[e]=t?t.join(" "):""},t.prototype._cacheInputObject=function(e,t){void 0===e&&(e="");var i=[];if(t)for(var r in t)t[r]&&i.push(r);this._inputMap[e]=i.join(" ")},t.prototype._cacheInputString=function(e,t){void 0===e&&(e=""),this._inputMap[e]=t},t}(ie),ne=function(){function e(e,t,i){this._mediaMonitor=e,this._elementRef=t,this._styler=i,this._inputMap={},this._hasInitialized=!1}return Object.defineProperty(e.prototype,"hasMediaQueryListener",{get:function(){return!!this._mqActivation},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"activatedValue",{get:function(){return this._mqActivation?this._mqActivation.activatedInput:void 0},set:function(e){var i,r="baseKey";this._mqActivation&&(r=this._mqActivation.activatedInputKey,i=this._inputMap[r],this._inputMap[r]=e);var n=new t.SimpleChange(i,e,!1);this.ngOnChanges((o={},o[r]=n,o));var o},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parentElement",{get:function(){return this._elementRef.nativeElement.parentNode},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"nativeElement",{get:function(){return this._elementRef.nativeElement},enumerable:!0,configurable:!0}),e.prototype._queryInput=function(e){return this._inputMap[e]},e.prototype.ngOnInit=function(){this._display=this._getDisplayStyle(),this._hasInitialized=!0},e.prototype.ngOnChanges=function(e){throw new Error("BaseFxDirective::ngOnChanges should be overridden in subclass: "+e)},e.prototype.ngOnDestroy=function(){this._mqActivation&&this._mqActivation.destroy(),delete this._mediaMonitor},e.prototype._getDefaultVal=function(e,t){var i=this._queryInput(e);return void 0!==i&&null!==i&&""!==i?i:t},e.prototype._getDisplayStyle=function(e){void 0===e&&(e=this.nativeElement);return this._styler.lookupStyle(e,"display")},e.prototype._getAttributeValue=function(e,t){return void 0===t&&(t=this.nativeElement),this._styler.lookupAttributeValue(t,e)},e.prototype._getFlowDirection=function(e,t){void 0===t&&(t=!1);var i="row",r="";if(e&&(a=this._styler.getFlowDirection(e),i=a[0],r=a[1],!r&&t)){var n=v(i),o=[e];this._styler.applyStyleToElements(n,o)}return i.trim()||"row";var a},e.prototype._applyStyleToElement=function(e,t,i){void 0===i&&(i=this.nativeElement),this._styler.applyStyleToElement(i,e,t)},e.prototype._applyStyleToElements=function(e,t){this._styler.applyStyleToElements(e,t)},e.prototype._cacheInput=function(e,t){if("object"==typeof t)for(var i in t)this._inputMap[i]=t[i];else e&&(this._inputMap[e]=t)},e.prototype._listenForMediaQueryChanges=function(e,t,i){if(!this._mqActivation){var r=new ee(e,t,this._inputMap);this._mqActivation=new te(r,this._mediaMonitor,function(e){return i(e)})}return this._mqActivation},Object.defineProperty(e.prototype,"childrenNodes",{get:function(){for(var e=this.nativeElement.children,t=[],i=e.length;i--;)t[i]=e[i];return t},enumerable:!0,configurable:!0}),e.prototype.hasResponsiveAPI=function(e){return Object.keys(this._inputMap).length-(this._inputMap[e]?1:0)>0},e.prototype.hasKeyValue=function(e){return this._mqActivation.hasKeyValue(e)},Object.defineProperty(e.prototype,"hasInitialized",{get:function(){return this._hasInitialized},enumerable:!0,configurable:!0}),e}(),oe=function(e){function r(t,i,r,n){var o=e.call(this,t,i,r)||this;return o._breakpoints=n,o.autoRegisterQueries=!0,o.useOverlaps=!1,o._actives=[],o._actives=[],o}return o(r,e),r.prototype.clearAll=function(){this._registry.forEach(function(e,t){e.destroy()}),this._registry.clear(),this.useOverlaps=!1},r.prototype.activate=function(e,t){return void 0===t&&(t=!1),t=t||this.useOverlaps,e=this._validateQuery(e),!t&&this.isActive(e)||(this._deactivateAll(),this._registerMediaQuery(e),this._activateWithOverlaps(e,t)),this.hasActivated},r.prototype._validateQuery=function(e){var t=this._breakpoints.findByAlias(e);return t&&(e=t.mediaQuery),e},r.prototype._activateWithOverlaps=function(e,t){if(t){var i=this._breakpoints.findByQuery(e),r=i?i.alias:"unknown";switch(r){case"lg":this._activateByAlias("lt-xl");break;case"md":this._activateByAlias("lt-xl, lt-lg");break;case"sm":this._activateByAlias("lt-xl, lt-lg, lt-md");break;case"xs":this._activateByAlias("lt-xl, lt-lg, lt-md, lt-sm")}switch(r){case"xl":this._activateByAlias("gt-lg, gt-md, gt-sm, gt-xs");break;case"lg":this._activateByAlias("gt-md, gt-sm, gt-xs");break;case"md":this._activateByAlias("gt-sm, gt-xs");break;case"sm":this._activateByAlias("gt-xs")}}return this._activateByQuery(e)},r.prototype._activateByAlias=function(e){var t=this,i=function(e){var i=t._breakpoints.findByAlias(e);t._activateByQuery(i?i.mediaQuery:e)};e.split(",").forEach(function(e){return i(e.trim())})},r.prototype._activateByQuery=function(e){var t=this._registry.get(e),i=this._actives.reduce(function(e,i){return e||t&&i.media===t.media},!1);return t&&!i&&this._actives.push(t.activate()),this.hasActivated},r.prototype._deactivateAll=function(){if(this._actives.length){for(var e=0,t=this._actives;e<t.length;e++){t[e].deactivate()}this._actives=[]}return this},r.prototype._registerMediaQuery=function(e){!this._registry.has(e)&&this.autoRegisterQueries&&this.registerQuery(e)},r.prototype._buildMQL=function(e){return new ae(e)},Object.defineProperty(r.prototype,"hasActivated",{get:function(){return this._actives.length>0},enumerable:!0,configurable:!0}),r.decorators=[{type:t.Injectable}],r.ctorParameters=function(){return[{type:t.NgZone},{type:Object,decorators:[{type:t.Inject,args:[t.PLATFORM_ID]}]},{type:void 0,decorators:[{type:t.Inject,args:[i.DOCUMENT]}]},{type:q}]},r}(F),ae=function(){function e(e){this._mediaQuery=e,this._isActive=!1,this._listeners=[]}return Object.defineProperty(e.prototype,"matches",{get:function(){return this._isActive},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"media",{get:function(){return this._mediaQuery},enumerable:!0,configurable:!0}),e.prototype.destroy=function(){this.deactivate(),this._listeners=[]},e.prototype.activate=function(){var e=this;return this._isActive||(this._isActive=!0,this._listeners.forEach(function(t){t(e)})),this},e.prototype.deactivate=function(){var e=this;return this._isActive&&(this._isActive=!1,this._listeners.forEach(function(t){t(e)})),this},e.prototype.addListener=function(e){-1===this._listeners.indexOf(e)&&this._listeners.push(e),this._isActive&&e(this)},e.prototype.removeListener=function(e){},e}(),se={provide:F,useClass:oe},ue=function(){function e(e){this._mediaQuery=e,this._isActive=!1,this._listeners=[]}return Object.defineProperty(e.prototype,"matches",{get:function(){return this._isActive},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"media",{get:function(){return this._mediaQuery},enumerable:!0,configurable:!0}),e.prototype.destroy=function(){this.deactivate(),this._listeners=[]},e.prototype.activate=function(){var e=this;return this._isActive||(this._isActive=!0,this._listeners.forEach(function(t){t(e)})),this},e.prototype.deactivate=function(){var e=this;return this._isActive&&(this._isActive=!1,this._listeners.forEach(function(t){t(e)})),this},e.prototype.addListener=function(e){-1===this._listeners.indexOf(e)&&this._listeners.push(e),this._isActive&&e(this)},e.prototype.removeListener=function(e){},e}(),pe=function(e){function n(t,i,n){var o=e.call(this,t,i,n)||this;return o._zone=t,o._platformId=i,o._document=n,o._registry=new Map,o._source=new r.BehaviorSubject(new V(!0)),o._observable$=o._source.asObservable(),o}return o(n,e),n.prototype.activateBreakpoint=function(e){var t=this._registry.get(e.mediaQuery);t&&t.activate()},n.prototype.deactivateBreakpoint=function(e){var t=this._registry.get(e.mediaQuery);t&&t.deactivate()},n.prototype._buildMQL=function(e){return new ue(e)},n.decorators=[{type:t.Injectable}],n.ctorParameters=function(){return[{type:t.NgZone},{type:Object,decorators:[{type:t.Inject,args:[t.PLATFORM_ID]}]},{type:void 0,decorators:[{type:t.Inject,args:[i.DOCUMENT]}]}]},n}(F),ce=function(){function e(e,t){this._breakpoints=e,this._matchMedia=t,this._registerBreakpoints()}return Object.defineProperty(e.prototype,"breakpoints",{get:function(){return this._breakpoints.items.slice()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"activeOverlaps",{get:function(){var e=this;return this._breakpoints.overlappings.reverse().filter(function(t){return e._matchMedia.isActive(t.mediaQuery)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"active",{get:function(){var e=this,t=null;this.breakpoints.reverse().forEach(function(i){""!==i.alias&&!t&&e._matchMedia.isActive(i.mediaQuery)&&(t=i)});var i=this.breakpoints[0];return t||(this._matchMedia.isActive(i.mediaQuery)?i:null)},enumerable:!0,configurable:!0}),e.prototype.isActive=function(e){var t=this._breakpoints.findByAlias(e)||this._breakpoints.findByQuery(e);return this._matchMedia.isActive(t?t.mediaQuery:e)},e.prototype.observe=function(e){var t=this._breakpoints.findByAlias(e||"")||this._breakpoints.findByQuery(e||""),i=function(e){return!t||""!==e.mqAlias};return this._matchMedia.observe(t?t.mediaQuery:e).pipe(n.map(function(e){return h(e,t)}),n.filter(i))},e.prototype._registerBreakpoints=function(){var e=this._breakpoints.sortedItems.map(function(e){return e.mediaQuery});this._matchMedia.registerQuery(e)},e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ctorParameters=function(){return[{type:q},{type:F}]},e.ngInjectableDef=t.defineInjectable({factory:function(){return new e(t.inject(q),t.inject(F))},token:e,providedIn:"root"}),e}(),le={provide:ce,deps:[[new t.Optional,new t.SkipSelf,ce],q,F],useFactory:b},ye={provide:U,deps:[[new t.Optional,new t.SkipSelf,U],F,q],useFactory:A},fe=function(){function e(e,t,i,r){this._serverStylesheet=e,this._serverModuleLoaded=t,this._platformId=i,this.layoutConfig=r}return e.prototype.applyStyleToElement=function(e,t,i){var r={};"string"==typeof t&&(r[t]=i,t=r),r=this.layoutConfig.disableVendorPrefixes?t:I(t),this._applyMultiValueStyleToElement(r,e)},e.prototype.applyStyleToElements=function(e,t){var i=this;void 0===t&&(t=[]);var r=this.layoutConfig.disableVendorPrefixes?e:I(e);t.forEach(function(e){i._applyMultiValueStyleToElement(r,e)})},e.prototype.getFlowDirection=function(e){var t=this.lookupStyle(e,"flex-direction");t===he&&(t="");var r=this.lookupInlineStyle(e,"flex-direction")||i.isPlatformServer(this._platformId)&&this._serverModuleLoaded?t:"";return[t||"row",r]},e.prototype.lookupAttributeValue=function(e,t){return e.getAttribute(t)||""},e.prototype.lookupInlineStyle=function(e,t){return i.isPlatformBrowser(this._platformId)?e.style[t]:this._getServerStyle(e,t)},e.prototype.lookupStyle=function(e,t,r){void 0===r&&(r=!1);var n="";if(e){(n=this.lookupInlineStyle(e,t))||(i.isPlatformBrowser(this._platformId)?r||(n=getComputedStyle(e).getPropertyValue(t)):this._serverModuleLoaded&&(n=this._serverStylesheet.getStyleForElement(e,t)))}return n?n.trim():he},e.prototype._applyMultiValueStyleToElement=function(e,t){var r=this;Object.keys(e).sort().forEach(function(n){var o=Array.isArray(e[n])?e[n]:[e[n]];o.sort();for(var a=0,s=o;a<s.length;a++){var u=s[a];i.isPlatformBrowser(r._platformId)||!r._serverModuleLoaded?i.isPlatformBrowser(r._platformId)?t.style.setProperty(n,u):r._setServerStyle(t,n,u):r._serverStylesheet.addStyleToElement(t,n,u)}})},e.prototype._setServerStyle=function(e,t,i){t=t.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();var r=this._readStyleAttribute(e);r[t]=i||"",this._writeStyleAttribute(e,r)},e.prototype._getServerStyle=function(e,t){return this._readStyleAttribute(e)[t]||""},e.prototype._readStyleAttribute=function(e){var t={},i=e.getAttribute("style");if(i)for(var r=i.split(/;+/g),n=0;n<r.length;n++){var o=r[n].trim();if(o.length>0){var a=o.indexOf(":");if(-1===a)throw new Error("Invalid CSS style: "+o);var s=o.substr(0,a).trim();t[s]=o.substr(a+1).trim()}}return t},e.prototype._writeStyleAttribute=function(e,t){var i="";for(var r in t){t[r]&&(i+=r+":"+t[r]+";")}e.setAttribute("style",i)},e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ctorParameters=function(){return[{type:Y,decorators:[{type:t.Optional}]},{type:void 0,decorators:[{type:t.Optional},{type:t.Inject,args:[G]}]},{type:void 0,decorators:[{type:t.Inject,args:[t.PLATFORM_ID]}]},{type:void 0,decorators:[{type:t.Inject,args:[N]}]}]},e.ngInjectableDef=t.defineInjectable({factory:function(){return new e(t.inject(Y,8),t.inject(G,8),t.inject(t.PLATFORM_ID),t.inject(N))},token:e,providedIn:"root"}),e}(),he="block";e.removeStyles=a,e.BROWSER_PROVIDER=E,e.CLASS_NAME=M,e.CoreModule=$,e.MediaChange=V,e.StylesheetMap=Y,e.STYLESHEET_MAP_PROVIDER_FACTORY=d,e.STYLESHEET_MAP_PROVIDER=Z,e.DEFAULT_CONFIG=C,e.LAYOUT_CONFIG=N,e.SERVER_TOKEN=G,e.BREAKPOINT=j,e.BaseDirective=ie,e.BaseDirectiveAdapter=re,e.BaseFxDirective=ne,e.RESPONSIVE_ALIASES=S,e.DEFAULT_BREAKPOINTS=P,e.ScreenTypes=R,e.ORIENTATION_BREAKPOINTS=D,e.BreakPointRegistry=q,e.BREAKPOINTS=K,e.MatchMedia=F,
e.MockMatchMedia=oe,e.MockMediaQueryList=ae,e.MockMatchMediaProvider=se,e.ServerMediaQueryList=ue,e.ServerMatchMedia=pe,e.MediaMonitor=ce,e.MEDIA_MONITOR_PROVIDER_FACTORY=b,e.MEDIA_MONITOR_PROVIDER=le,e.ObservableMedia=U,e.MediaService=W,e.ObservableMediaProvider=H,e.OBSERVABLE_MEDIA_PROVIDER_FACTORY=A,e.OBSERVABLE_MEDIA_PROVIDER=ye,e.KeyOptions=ee,e.ResponsiveActivation=te,e.StyleUtils=fe,e.validateBasis=w,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=flex-layout-core.umd.min.js.map
